万年不更了,随便写点什么吧。
首先最小生成树的两种求法 Kruskal 和 Prim,强行丢链接。
其他还有一个 Borůvka 算法,大概思路就是每次将每个集合伸出去的最短的那条边选入,选入后将两个集合合并成一个新的集合,考虑到每次集合个数减半,所以复杂度 O(𝑚log𝑛)。偷了张 Wikipedia 的图:

那这东西有什么用呢?有这么一道题,大概是有一个 𝑛(𝑛≤200000) 个点的完全图,每个节点的编号为 𝑎𝑖(0≤𝑎𝑖<230),𝑖 与 𝑗 的边的权值是 𝑎𝑖⨂𝑎𝑗,⨂ 是按位异或,求该图的最小生成树。
这道题大概用到了 Borůvka 的思想,先用所有点权建一棵 Trie 树,考虑 Trie 树上一棵子树,显然一开始肯定是他们自己连成一棵 MST,然后再和其兄弟连一条边,因为跨越子树像兄弟连一条边需要 2𝑑 的代价,𝑑 是节点深度,显然自己连更优,于是建出 Trie 树之后分治(其实就是 dfs)下去即可。
具体代码可以戳这里。
有一道叫最小 mex 生成树的题目,题目大意是给定 𝑛 个点 𝑚 条边的无向连通图,求一棵生成树,使得其边权集合的 mex 尽可能小。1≤𝑛≤106,1≤𝑚≤105,0≤𝑤≤105。
考虑一个做法:枚举答案 𝑥,把边权为 𝑥 的所有边全部删掉,看看能不能构成一棵生成树。
建一棵以边权为下标的线段树,对于每条边权为 𝑤 的边将其放到 [0,𝑤−1] 和 [𝑤+1,105] 上。然后在线段树上遍历,遍历到一个节点就将它上面挂着的边连上,这样子到叶结点时就连上了所有不包含该边权的边,用可撤销并查集判断图是否连通即可。
用可撤销按秩合并并查集,复杂度 O(𝑛log2𝑛)。并不是很懂为什么两只 log 能过 106。
最小比率生成树,也就是给你一张图,每条边有一个非负权值 𝑎𝑖,𝑏𝑖,求一棵生成树 𝑇,使得 ∑𝑒∈𝑇𝑎𝑒∑𝑒∈𝑇𝑏𝑒 最小。
大概就是一个 01 分数规划问题,我们可以考虑二分答案 𝑙,条件是 ∑𝑒∈𝑇𝑎𝑒∑𝑒∈𝑇𝑏𝑒≤𝑙,也就是 ∑𝑒∈𝑇𝑎𝑒−𝑙⋅𝑏𝑒≤0。
考虑到 𝑎𝑖≥0,𝑏𝑖≥0,所以左边的东西肯定随 𝑙 递减。
以 𝑎𝑖−𝑙⋅𝑏𝑖 为边权建树二分即可。
模板题大概是这道,代码可以戳这里。
接下来是那到经典的 wqs 二分好题,题目大意就是给你一个无向带权连通图,每条边是黑色或白色。让你求一棵最小权的恰好有 𝑥 条白色边的生成树。𝑉≤50000,𝐸≤100000,边权为 [1,100] 中的整数。
首先我们先要知道 wqs 二分是什么,那就先说一道题吧,大概就是有一个长度为 𝑛(𝑛≤105) 的正整数序列 {𝑎},要分成 𝐾 段,第 𝑖 段之和记为 𝑠𝑖,求最小的 ∑𝐾𝑖=1𝑠2𝑖。
我们令 𝑓𝑘 表示分成 𝑘 段的最小值,有一个显然的结论就是 𝑓𝑘 是递减的,因为 (𝑎+𝑏)2>𝑎2+𝑏2,把一段给拆开来肯定更优。
我们来考虑 𝑓 的差分数列,我们发现 𝑓 的差分数列是单调不增的。感觉我的证明比较口胡,大家意会一下就可以了。如果大家对证明没什么兴趣,也可以不跳过这一段,反正只要意会一下这是单调的就可以了。我们考虑从分成 𝑘 段到分成 𝑘−1 段的情况,也就是说,要把段数减 1。此时,有两种办法,一种是合并其中的两段,另一种是拆掉原有的一些段。首先看合并两段。考虑到如果合并这两段所假的量比 𝑓𝑘+1−𝑓𝑘 要小,那么 𝑘+1→𝑘 的时候就应该合并这两段。当然可能这两段可能是 𝑘+1→𝑘 的时候出现的,这时候我们考虑到 𝑎⋅(𝑏+𝑐)≥𝑎𝑏 即可。还有一种方法就是拆掉一些段然后合并。不难发现这其实只有和二分图增广一样的情况,就是 0101010 变成 1010101。如果 𝑘+1→𝑘 所生成的段和这些段无关,那显然这样操作的代价比 𝑘+1→𝑘 的代价劣,如果有关,我们考虑这一段,如果 𝑘→𝑘−1 的代价比 𝑘+1→𝑘 优,考虑 𝑘→𝑘−1 这一次“增广”时该块所断开的那个位置,我们考虑 𝑘+1→𝑘 时不将那一段合并,而是将我们刚才找到的那个位置向左侧或右侧跟 𝑘→𝑘−1 这样的样子的方向进行“增广”,不难证明这样做的代价优于 𝑓𝑘+1−𝑓𝑘,而由于我们之前认为 𝑓𝑘+1−𝑓𝑘 是最优的,矛盾了,所以不合。综上,我们可以发现 𝑓 的差分数列是单调不增的,也就是说,是一个凸壳。
那我们既然我们得到了一个凸壳,但是我们并不知道凸壳上具体点的纵坐标,我们考虑一个做法:考虑用一条直线 𝑦=𝑘𝑥+𝑏 去切这个凸壳,我们二分 𝑘,如果能快速求出 𝑏 和具体切到了凸壳上的那一个点,那么就能得出答案。
对于这道题,我们发现二分的 𝑘 其实就是给每段增加了一个代价,也就是说,每段的代价不再是 𝑠2𝑖,而是 𝑠2𝑖−𝑘(显然,这里需要二分的 𝑘 是负数)。这样做有一个好处,就是我们不必考虑需要选 𝐾 段的限制,而是只要求出最优解分成了几段(也就是切到了那个点),以及最优解的答案(也就是 𝑏)即可。
这个东西我们可以考虑一个朴素的 dp,令 𝑔𝑖 表示以 𝑖 结尾的答案,显然我们有:
𝑔𝑖=𝑖−1min𝑗=1⎛⎜
⎜⎝𝑔𝑗+(𝑖∑𝑡=𝑗𝑎𝑡)2⎞⎟
⎟⎠−𝑘
我们令 𝑆𝑖=∑𝑖𝑗=1𝑎𝑗,不难得到:
𝑔𝑖=𝑖−1min𝑗=1(𝑔𝑗+𝑠2𝑗−2𝑠𝑖𝑠𝑗)−𝑘−𝑠2𝑖
不难发现这个东西可以斜率优化,于是我们就可以顺利地解决这道题。
我们回过头来看之前那道题:给你一个无向带权连通图,每条边是黑色或白色。让你求一棵最小权的恰好有 𝑥 条白色边的生成树。
这道题的答案似乎并不是随 𝑥 单调的,应该是一个单峰的函数,但是我们考虑其差分数列,发现其也是单调的。因为想象如果你必须扔掉一条边而去选择另一种颜色一条边,那一定是有很多中选择(如弃 𝑎 选 𝑏,弃 𝑐 选 𝑑),而这些决策是独立的,我们可以选择任意一个,而显然是会去选择最小的一个。于是这仍然是一个凸壳。我们仍然能用刚才的思路,用一条直线去卡,二分斜率,发现斜率就是给每条白色边加一个权值,然后就可以直接做了。如果先将黑白边分别排序,最后每次二分是归并一下,那么排序的复杂度变成了 O(𝐸),于是复杂度 O(𝐸log𝐶𝛼(𝑉)),𝐶 是二分范围。
接着应该是严格次小生成树,题目就是让你求一棵严格次小生成树吧。其实也很简单,首先发现任意一棵最小生成树都可以通过加一条边再删一条边变成一棵严格次小生成树,于是就可以建出一棵最小生成树,用倍增、树剖或是 LCT 维护链最大值,每次枚举一条非树边尝试删除一条树边,复杂度 O(𝑛log2𝑛)/O(𝑛log𝑛)。代码看这里。
最小权值生成树?就是要求 ∑𝑤𝑖𝑠𝑖 最小。𝑤𝑖 是 𝑖 以 1 为根时与父亲边权的大小,𝑤1=0,𝑠𝑖 是以 1 为根时 𝑖 的子树大小。1≤𝑛,𝑚≤105,𝑤𝑖≥0。
发现 ∑𝑤𝑖𝑠𝑖=∑𝑑𝑖,𝑑𝑖 表示 𝑖 到 1 的距离,于是最短路径树即是答案。
最小极差生成树?首先有一个 O(𝑚2) 的做法,就是枚举最小边,然后就是最小瓶颈生成树了,直接 Kruskal。
然后我们发现我们可以倒着枚举边,每次加入一个最小的,形成一个环,显然是删去环中最大的,这个我们可以直接用 LCT 维护,维护边权的时候将边变成一个虚点即可。时间复杂度 O(𝑚log(𝑛+𝑚))。
模板题可以看这道,代码可以看这里。有一个大坑就是这道题有自环。
还有最小乘积生成树。就是每条边有两个权值 𝑎𝑖,𝑏𝑖,求一棵生成树 𝑇,最小化 ∑𝑒∈𝑇𝑎𝑒×∑𝑒∈𝑇𝑏𝑒。数据范围 1≤𝑛≤200,1≤𝑚≤10000,0≤𝑎𝑖≤𝑏𝑖≤255。
考虑将每棵最小生成树 𝑇 都映射到一个点 (∑𝑒∈𝑇𝑎𝑒,∑𝑒∈𝑇𝑏𝑒)。也就是求其与 (0,0) 所围成的面积最小。
然后就不难发现答案一定在凸壳上,我们考虑找到这个凸壳。
有一种叫做 Quick-Hull 的找凸包的方法,就是选取两个凸包上的点,连成一条线,找到距离这条线最远的点(一侧),然后分治下去(继续偷一张 Wikipedia 上的图):

这种方法可以用在这道题目上,我们考虑先找到两个点,最好找的就是左上角和右下角了,一个是以 𝑎 建一棵最小生成树,另一个以 𝑏 建最小生成树。
然后我们考虑找最远的点,那显然就是面积最大的点,也就是说,如果我们找到左上角的点 𝐴(𝑥𝑎,𝑦𝑎),右下角 𝐵(𝑥𝑏,𝑦𝑏),我们要找一个点 𝐶(𝑥𝑐,𝑦𝑐),我们要最大化 ⟶𝐴𝐶×⟶𝐴𝐵。
我们考虑到:
⟶𝐴𝐶×⟶𝐴𝐵=(𝑥𝑐−𝑥𝑎,𝑦𝑐−𝑦𝑎)×(𝑥𝑏−𝑥𝑎,𝑦𝑏−𝑦𝑎)=(𝑥𝑐−𝑥𝑎)⋅(𝑦𝑏−𝑦𝑎)−(𝑥𝑏−𝑥𝑎)⋅(𝑦𝑐−𝑦𝑎)=𝑥𝑐𝑦𝑏−𝑥𝑐𝑦𝑎−𝑥𝑎𝑦𝑏+𝑥𝑎𝑦𝑎−𝑥𝑏𝑦𝑐+𝑥𝑎𝑦𝑐+𝑥𝑏𝑦𝑎−𝑥𝑎𝑦𝑎=𝑥𝑐(𝑦𝑏−𝑦𝑎)+𝑦𝑐(𝑥𝑎−𝑥𝑏)+𝑥𝑏𝑦𝑎−𝑥𝑎𝑦𝑏
考虑到 𝑥𝑏𝑦𝑎−𝑥𝑎𝑦𝑏 是一个定值,我们只要最大化 𝑥𝑐(𝑦𝑏−𝑦𝑎)+𝑦𝑐(𝑥𝑎−𝑥𝑏),即最小化 𝑥𝑐(𝑦𝑎−𝑦𝑏)+𝑦𝑐(𝑥𝑏−𝑥𝑎) 即可。
于是我们只要将边权定为 𝑎𝑐(𝑦𝑎−𝑦𝑏)+𝑏𝑐(𝑥𝑏−𝑥𝑎),然后就一遍最小生成树即可。
复杂度?大概口胡一下:决策点应该是有 O(𝑛𝑛−2) 个。关于其会使凸包上的点期望有多少个,自己实测了一下感觉像是 O(log𝑛) 的,后来在知乎上看到了一篇奇怪的证明,说确实是 O(log𝑛),但是听说这个证明有点锅,然后有找到了一篇论文,并不是很懂里面的内容,有兴趣的可以看一下。于是凸包上的期望点数应该是 O(log(𝑛𝑛−2))=O(𝑛log𝑛) 的。每次找一个点的复杂度是 O(𝑚log𝑚) 的,所以期望复杂度应该是 O(𝑛𝑚log𝑛log𝑚)。
模板题在这里,代码在这里。
关于这个问题的复杂度在知乎上翻到了一个奇怪的讨论,大家可以去看看。
然后是 Matrix-Tree 定理。关于这部分内容的很多东西均偷自这篇论文。
在此之前先需要介绍一下行列式是什么,首先我们来先介绍一下置换。关于置换,记为
(12⋯𝑛𝑎1𝑎2⋯𝑎𝑛)
其中 𝑎 是 1∼𝑛 的一个排列。
显然对于任意一个排列,要将其排序的话,其交换次数的奇偶性与交换方式无关,我们令最小交换次数为 𝑡,我们定义:
𝛿(12⋯𝑛𝑎1𝑎2⋯𝑎𝑛)=(−1)𝑡
然后是行列式,其实说白了他是一个函数,将一个 𝑛×𝑛 的矩阵映射到了一个标量,我们记为 det𝐴 或 |𝐴|。我们定义:
det𝐴=∑⎛⎜
⎜
⎜⎝12⋯𝑛𝑖1𝑖2⋯𝑖𝑛⎞⎟
⎟
⎟⎠𝛿(12⋯𝑛𝑖1𝑖2⋯𝑖𝑛)𝑛∏𝑗=1𝑎𝑗,𝑖𝑗
观察上式,我们可以得到一些性质,考虑到这些性质都可以直接由定义得到,证明就不再一一展开。
首先,我们有:
det𝐴T=det𝐴
𝐴T 是 𝐴 的转置,大概就是这样子吧:

这暗示着我们,行列式中行和列是等价的,下面在讨论行的问题时,列都是一样的。
然后是如果将行列式中的两行互换,那么行列式变号。于是我们有一个推论,那就是如果矩阵 𝐴 中两行相同,那么交换这两行不会改变 𝐴,于是我们有 det𝐴=−det𝐴,即 det𝐴=0。
在行列式中,某一行的每个元素是两数之和,则此行列式可拆分为两个相加的行列式。
∣
∣
∣
∣
∣𝑎11𝑎12…𝑎1𝑛⋮⋮…⋮𝑎𝑖1+𝑏𝑖1𝑎𝑖2+𝑏𝑖2…𝑎𝑖𝑛+𝑏𝑖𝑛⋮⋮⋱⋮𝑎𝑛1𝑎𝑛2…𝑎𝑛𝑛∣
∣
∣
∣
∣=∣
∣
∣
∣
∣𝑎11𝑎12…𝑎1𝑛⋮⋮…⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛⋮⋮⋱⋮𝑎𝑛1𝑎𝑛2…𝑎𝑛𝑛∣
∣
∣
∣
∣+∣
∣
∣
∣
∣𝑎11𝑎12…𝑎1𝑛⋮⋮…⋮𝑏𝑖1𝑏𝑖2…𝑏𝑖𝑛⋮⋮⋱⋮𝑎𝑛1𝑎𝑛2…𝑎𝑛𝑛∣
∣
∣
∣
∣
根据上面一条,我们可以得到,如果将矩阵的一行或是一列都乘以一个数 𝜆,那么该矩阵的行列式也将乘以 𝜆。结合上面那个性质的推论,我们不难发现如果矩阵中有两行或两列成比例,那么该矩阵的行列式为 0。
∣
∣
∣
∣
∣𝑎11𝑎12…𝑎1𝑛⋮⋮…⋮𝑘𝑎𝑖1𝑘𝑎𝑖2…𝑘𝑎𝑖𝑛⋮⋮⋱⋮𝑎𝑛1𝑎𝑛2…𝑎𝑛𝑛∣
∣
∣
∣
∣=𝑘∣
∣
∣
∣
∣𝑎11𝑎12…𝑎1𝑛⋮⋮…⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛⋮⋮⋱⋮𝑎𝑛1𝑎𝑛2…𝑎𝑛𝑛∣
∣
∣
∣
∣
根据上面的东西,我们就可以发现:
∣
∣
∣
∣
∣⋮⋮⋮⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛𝑎𝑗1𝑎𝑗2…𝑎𝑗𝑛⋮⋮⋮⋮∣
∣
∣
∣
∣=∣
∣
∣
∣
∣⋮⋮⋮⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛𝑎𝑗1𝑎𝑗2…𝑎𝑗𝑛⋮⋮⋮⋮∣
∣
∣
∣
∣+∣
∣
∣
∣
∣⋮⋮⋮⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛𝑘𝑎𝑖1𝑘𝑎𝑖2…𝑘𝑎𝑖𝑛⋮⋮⋮⋮∣
∣
∣
∣
∣=∣
∣
∣
∣
∣⋮⋮⋮⋮𝑎𝑖1𝑎𝑖2…𝑎𝑖𝑛𝑎𝑗1+𝑘𝑎𝑖1𝑎𝑗2+𝑘𝑎𝑖2…𝑎𝑗𝑛+𝑘𝑎𝑖𝑛⋮⋮⋮⋮∣
∣
∣
∣
∣
也就是说,我们可以把行列式中的某行的每个环诉乘上一个常数 𝑘,加到另一行上去。
根据这一个性质,我们不难使用类似高斯消元的做法吧行列式转换成上三角的形式:
∣
∣
∣
∣
∣
∣𝑎1,1𝑎1,2𝑎1,3…𝑎1,𝑛𝑎2,2𝑎2,3…𝑎2,𝑛⋮⋱⋱⋮(0)⋱𝑎𝑛−1,𝑛0⋯𝑎𝑛,𝑛∣
∣
∣
∣
∣
∣=𝑛∏𝑖=1𝑎𝑖,𝑖
于是我们就可以 O(𝑛3) 计算行列式啦!
这里有一道模板题,其中有模数 𝑝,不保证是质数。
由于不是质数,所以可能不存在逆元。我们考虑在消元的时候,使用类似辗转相除的方法。这样时间复杂度 O(𝑛3log𝑛)。代码在这儿。
当然,我们还有能发现,如果矩阵 𝐴 中每一行和为 0,那么我们可以把矩阵中的第一列加上其余各列,这样子第一列就全 0 了,于是 det𝐴=0。
接下来是一个非常牛逼的东西叫做柯西-比内公式,大概就是假设 𝐴 是一个 𝑚×𝑛 的矩阵,𝐵 是一个 𝑛×𝑛 的矩阵,如果 𝑆 是 1,…,𝑛 中具有 𝑚 个元素的子集,我们记 𝐴𝑆 为 𝐴 中列下标位于 𝑆 中的 𝑚×𝑚 子矩阵。类似地,记 𝐵𝑆 为 𝐵 中行下标位于 𝑆 中的 𝑚×𝑚 子矩阵。Binet-Cauchy 公式说:
det(𝐴𝐵)=∑det𝐴𝑆⋅det𝐵𝑆
这个东西我太菜了不会证啊,如果有兴趣的同学可以自己看论文或是水知乎。
根据上面的公式,当 𝑛=𝑚 时,det(𝐴𝐵)=det𝐴det𝐵
然后我们会到生成树上来,问题大概就是让你求一张无向图的生成树个数,𝑛≤100。
先说结论,假设给出图为 𝐺,定义一个 𝑛×𝑛 的矩阵 𝐷(𝐺) 表示 𝐺 个点的度数,当 𝑖≠𝑗 时,𝑑𝑖,𝑗=0,当 𝑖=𝑗 时,𝑑𝑖,𝑗 等于节点 𝑖 的度数。再定义一个 𝑛×𝑛 的矩阵 𝐴𝐺 表示 𝐺 的邻接矩阵,𝐴𝑖,𝑗 表示 𝑖 到 𝑗 的边数。然后我们定义基尔霍夫矩阵 𝐶(𝐺)=𝐷(𝐺)−𝐴(𝐺)。则 𝐺 中生成树个数等于 𝐶(𝐺) 中任意一个 𝑛−1 阶主子式的行列式的绝对值。所谓一个矩阵 𝑀 的 𝑛−1 阶主子式就是对于两个整数 𝑟(1≤𝑟≤𝑛),将 𝑀 去掉第 𝑟 行和第 𝑟 列后形成的 𝑛−1 阶的矩阵,记作 𝑀𝑟。
举个栗子,比如说现在有这样张图,其生成树有 8 个(直接偷 Wikipedia 上的图了):

其度数矩阵
𝐷(𝐺)=⎡⎢
⎢
⎢
⎢⎣2000030000300002⎤⎥
⎥
⎥
⎥⎦
其邻接矩阵
𝐴(𝐺)=⎡⎢
⎢
⎢
⎢⎣0110101111010110⎤⎥
⎥
⎥
⎥⎦
于是其基尔霍夫矩阵
𝐶(𝐺)=⎡⎢
⎢
⎢
⎢⎣2−1−10−13−1−1−1−13−10−1−12⎤⎥
⎥
⎥
⎥⎦
我们取 𝑟=2,得到其主子式
𝐶2(𝐺)=⎡⎢
⎢⎣2−10−13−10−12⎤⎥
⎥⎦
得到的行列式
det𝐶2(𝐺)=∣2−10−13−10−12∣=∣
∣
∣
∣2−10052−10085∣
∣
∣
∣=2×52×85=8
那为什么是这样呢?
首先我们来观察一下 𝐶(𝐺) 的性质。我们考虑如果我们把两个点在矩阵中的出现顺序交换,其实就是把行交换一次,列交换一次,一共交换偶数次,所以行列式不变。于是我们发现,𝐶(𝐺) 和 𝐶𝑟(𝐺) 的行列式与其顶点的顺序无关。
我们考虑构造一个 𝑛×𝑚(𝑛 是点数,𝑚 是边数)的矩阵 𝐵,如果对于第 𝑖 条边,如果连接 ⟨𝑢,𝑣⟩,那么我们就令 𝑏𝑢,𝑖=1,𝑏𝑣,𝑖=−1,其余都是 0。其实谁是 1 谁是 −1 不重要,因为是无向图,只要一个是 −1 一个是 1 即可。
接下来,我们考虑 𝐵𝐵T。我们发现对于 (𝐵𝐵T)𝑖,𝑗,如果 𝑖=𝑗,那么 (𝐵𝐵T)𝑖,𝑗=∑𝑚𝑘=1𝐵2𝑖,𝑘,也就是 𝑖 的度数;如果 𝑖≠𝑗,那么 (𝐵𝐵T)𝑖,𝑗=∑𝑚𝑘=1𝐵𝑖,𝑘𝐵𝑗,𝑘,也就是 𝑖 到 𝑗 的边数的相反数。于是我们发现,𝐵𝐵T 就是基尔霍夫矩阵,即 𝐶(𝐺)=𝐵𝐵T。
令 𝐻 表示 𝐵 去掉 𝑟 行后的矩阵,易得 𝐶(𝐺)𝑟=𝐻𝐻T。于是根据 Binet-Cauchy 公
式,我们可以得到:
det𝐶(𝐺)=det(𝐻𝐻T)=∑𝑆det𝐻𝑆det𝐻T𝑆=∑𝑆(det𝐻𝑆)2=∑𝑆det𝐻2𝑆
我们观察这只式子,发现他其实就是在干这样一件事情:每次在这 𝑚 条边中取出 𝑛−1 条,并对答案计入 det𝐻2𝑆 的贡献。
那我们来看这个 det𝐻2𝑆。我们将 𝑆 中选出的这些边组合成一个集合,和 𝑛 个点组合成一张图,记为 𝐺′,不难发现 𝐶(𝐺′)=𝐻2𝑆,于是 det𝐻2𝑆=det𝐶(𝐺′)。
然后我们考虑一个基尔霍夫矩阵 𝐶(𝐺),由于其各行各列之和均为 0,det𝐶(𝐺)=0。如果 𝐺 是一个非连通图,那么我们发现 𝐶(𝐺) 一定可以通过调整点的编号变成这样:
⎡⎢
⎢
⎢
⎢
⎢
⎢
⎢⎣𝑎1,1…𝑎1,𝑘0…0⋮⋱⋮⋮⋱⋮𝑎𝑘,1…𝑎𝑘,𝑘0…00…0𝑎𝑘+1,𝑘+1…𝑎𝑘+1,𝑛⋮⋱⋮⋮⋱⋮0…0𝑎𝑛,𝑘+1…𝑎𝑛,𝑛⎤⎥
⎥
⎥
⎥
⎥
⎥
⎥⎦
不难发现这两个连通块都可以独立地变成一个上三角。由于 𝐶𝑟(𝐺) 只抽走了一行和一列,那也就是说肯定有一个块最后对角线上有一个 0,于是行列式的值为 0。
所以说,如果 𝐺′ 不是连通图,那其对答案的贡献是 0,考虑到 𝐺′ 只有 𝑛−1 条边,如果联通,那肯定只能是棵树了。于是我们来考虑数的情况。
不要忘了我们扔出去了一个 𝑟,我们以 𝑟 为根对这棵树进行 dfs,将节点重新按照 dfs 序标号。然后我们从大往小倒着来。考虑对每个点,用他去消他的父亲。也就是说,将它父亲的每那一行减去自己的那一行。不难发现,如果这样做,主对角线都是 1,因为只有它与它父亲的那条边没被减,其他边都被儿子减掉了。这样就形成了一个下三角矩阵,我们把它转置一下就变成了上三角,其贡献就是对角线的乘积,也就是 1。于是他对答案的贡献就是 1。
我们再来回顾一下这只式子:
det𝐶(𝐺)=∑𝑆det𝐻2𝑆
经过上面的论证,如果 𝐺′ 是棵树,那么 det𝐻2𝑆=1,否则 det𝐻2𝑆=0。也就是说,这个式子在枚举所有 𝑛−1 条边的子集,如果这个子集是一棵生成树,那么就将答案加 1,于是我们成功在 O(𝑛3) 的时间复杂度内完成了生成树计数问题。
那就让我们来做一下这道模板题,代码在这里。
然后是最小生成树计数。这个大概就是发现每个最小生成树每种边权的边数应该是一样的,且将这些边去掉后所得的连通块相同。
于是我们考虑建出一棵最小生成树,枚举边权然后把原来最小生成树上该边权的边删掉,然后跑矩阵树。
复杂度?假设离散之后边权 𝑖 共有 𝑎𝑖 条边,那么显然 ∑𝑎𝑖=𝑚。如果图没有重边,则 Kruscal 复杂度 O(𝑚log𝑚),矩阵树复杂度为 O(∑(𝑛+𝑚+min(𝑛,𝑎𝑖)3)),由于没有重边,前面的 𝑛+𝑚 那一项卡满不过 O(𝑚×(𝑛+𝑚))=O(𝑚2)=O(𝑛2𝑚),而后面那一项当每个 𝑎𝑖 取到 𝑛 时最大,即 O(𝑚𝑛×𝑛3)=O(𝑛2𝑚),所以总复杂度 O(𝑛2𝑚)。
模板题在这儿,代码在这儿。
那如何计算树形图呢?我们先考虑树是叶子向根的情况。我们考虑刚才的证明,不难构造出树形图的解。大概就是将原来的度数矩阵改成出度矩阵,然后定义基尔霍夫矩阵。这样一棵树已经可以直接变成一个上三角了。我们考虑枚举 𝑟,对每个 𝑟 都做一遍矩阵树,最后求和即可。
那从根向叶子呢?把边反一反就可以了。具体直接把出度矩阵改成入度矩阵即可。
矩阵树就暂时到这儿吧。
未完待续……
列几篇写这篇博客时看到的有趣的文章,上面的很多内容很多参考抄自这些文章,当然有些文章看不懂,也列在了这里: